import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { ComputeManagementClientContext } from "../computeManagementClientContext";
/** Class representing a CommunityGalleries. */
export declare class CommunityGalleries {
    private readonly client;
    /**
     * Create a CommunityGalleries.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    constructor(client: ComputeManagementClientContext);
    /**
     * Get a community gallery by gallery public name.
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param [options] The optional parameters
     * @returns Promise<Models.CommunityGalleriesGetResponse>
     */
    get(location: string, publicGalleryName: string, options?: msRest.RequestOptionsBase): Promise<Models.CommunityGalleriesGetResponse>;
    /**
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param callback The callback
     */
    get(location: string, publicGalleryName: string, callback: msRest.ServiceCallback<Models.CommunityGallery>): void;
    /**
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param options The optional parameters
     * @param callback The callback
     */
    get(location: string, publicGalleryName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.CommunityGallery>): void;
}
//# sourceMappingURL=communityGalleries.d.ts.map