/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/communityGalleryImageVersionsMappers";
import * as Parameters from "../models/parameters";
/** Class representing a CommunityGalleryImageVersions. */
var CommunityGalleryImageVersions = /** @class */ (function () {
    /**
     * Create a CommunityGalleryImageVersions.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    function CommunityGalleryImageVersions(client) {
        this.client = client;
    }
    CommunityGalleryImageVersions.prototype.get = function (location, publicGalleryName, galleryImageName, galleryImageVersionName, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            publicGalleryName: publicGalleryName,
            galleryImageName: galleryImageName,
            galleryImageVersionName: galleryImageVersionName,
            options: options
        }, getOperationSpec, callback);
    };
    return CommunityGalleryImageVersions;
}());
export { CommunityGalleryImageVersions };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/communityGalleries/{publicGalleryName}/images/{galleryImageName}/versions/{galleryImageVersionName}",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.location0,
        Parameters.publicGalleryName,
        Parameters.galleryImageName,
        Parameters.galleryImageVersionName
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.CommunityGalleryImageVersion
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=communityGalleryImageVersions.js.map