import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { ComputeManagementClientContext } from "../computeManagementClientContext";
/** Class representing a CommunityGalleryImages. */
export declare class CommunityGalleryImages {
    private readonly client;
    /**
     * Create a CommunityGalleryImages.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    constructor(client: ComputeManagementClientContext);
    /**
     * Get a community gallery image.
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param galleryImageName The name of the community gallery image definition.
     * @param [options] The optional parameters
     * @returns Promise<Models.CommunityGalleryImagesGetResponse>
     */
    get(location: string, publicGalleryName: string, galleryImageName: string, options?: msRest.RequestOptionsBase): Promise<Models.CommunityGalleryImagesGetResponse>;
    /**
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param galleryImageName The name of the community gallery image definition.
     * @param callback The callback
     */
    get(location: string, publicGalleryName: string, galleryImageName: string, callback: msRest.ServiceCallback<Models.CommunityGalleryImage>): void;
    /**
     * @param location Resource location.
     * @param publicGalleryName The public name of the community gallery.
     * @param galleryImageName The name of the community gallery image definition.
     * @param options The optional parameters
     * @param callback The callback
     */
    get(location: string, publicGalleryName: string, galleryImageName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.CommunityGalleryImage>): void;
}
//# sourceMappingURL=communityGalleryImages.d.ts.map