/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/communityGalleryImagesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a CommunityGalleryImages. */
var CommunityGalleryImages = /** @class */ (function () {
    /**
     * Create a CommunityGalleryImages.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    function CommunityGalleryImages(client) {
        this.client = client;
    }
    CommunityGalleryImages.prototype.get = function (location, publicGalleryName, galleryImageName, options, callback) {
        return this.client.sendOperationRequest({
            location: location,
            publicGalleryName: publicGalleryName,
            galleryImageName: galleryImageName,
            options: options
        }, getOperationSpec, callback);
    };
    return CommunityGalleryImages;
}());
export { CommunityGalleryImages };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Compute/locations/{location}/communityGalleries/{publicGalleryName}/images/{galleryImageName}",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.location0,
        Parameters.publicGalleryName,
        Parameters.galleryImageName
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.CommunityGalleryImage
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=communityGalleryImages.js.map