import * as msRest from "@azure/ms-rest-js";
import * as msRestAzure from "@azure/ms-rest-azure-js";
import * as Models from "../models";
import { ComputeManagementClientContext } from "../computeManagementClientContext";
/** Class representing a GallerySharingProfile. */
export declare class GallerySharingProfile {
    private readonly client;
    /**
     * Create a GallerySharingProfile.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    constructor(client: ComputeManagementClientContext);
    /**
     * Update sharing profile of a gallery.
     * @param resourceGroupName The name of the resource group.
     * @param galleryName The name of the Shared Image Gallery.
     * @param sharingUpdate Parameters supplied to the update gallery sharing profile.
     * @param [options] The optional parameters
     * @returns Promise<Models.GallerySharingProfileUpdateResponse>
     */
    update(resourceGroupName: string, galleryName: string, sharingUpdate: Models.SharingUpdate, options?: msRest.RequestOptionsBase): Promise<Models.GallerySharingProfileUpdateResponse>;
    /**
     * Update sharing profile of a gallery.
     * @param resourceGroupName The name of the resource group.
     * @param galleryName The name of the Shared Image Gallery.
     * @param sharingUpdate Parameters supplied to the update gallery sharing profile.
     * @param [options] The optional parameters
     * @returns Promise<msRestAzure.LROPoller>
     */
    beginUpdate(resourceGroupName: string, galleryName: string, sharingUpdate: Models.SharingUpdate, options?: msRest.RequestOptionsBase): Promise<msRestAzure.LROPoller>;
}
//# sourceMappingURL=gallerySharingProfile.d.ts.map