import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { ComputeManagementClientContext } from "../computeManagementClientContext";
/** Class representing a VirtualMachineSizes. */
export declare class VirtualMachineSizes {
    private readonly client;
    /**
     * Create a VirtualMachineSizes.
     * @param {ComputeManagementClientContext} client Reference to the service client.
     */
    constructor(client: ComputeManagementClientContext);
    /**
     * This API is deprecated. Use [Resources
     * Skus](https://docs.microsoft.com/rest/api/compute/resourceskus/list)
     * @param location The location upon which virtual-machine-sizes is queried.
     * @param [options] The optional parameters
     * @returns Promise<Models.VirtualMachineSizesListResponse>
     */
    list(location: string, options?: msRest.RequestOptionsBase): Promise<Models.VirtualMachineSizesListResponse>;
    /**
     * @param location The location upon which virtual-machine-sizes is queried.
     * @param callback The callback
     */
    list(location: string, callback: msRest.ServiceCallback<Models.VirtualMachineSizeListResult>): void;
    /**
     * @param location The location upon which virtual-machine-sizes is queried.
     * @param options The optional parameters
     * @param callback The callback
     */
    list(location: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.VirtualMachineSizeListResult>): void;
}
//# sourceMappingURL=virtualMachineSizes.d.ts.map