/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __extends } from "tslib";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as operations from "./operations";
import { ManagementLockClientContext } from "./managementLockClientContext";
var ManagementLockClient = /** @class */ (function (_super) {
    __extends(ManagementLockClient, _super);
    /**
     * Initializes a new instance of the ManagementLockClient class.
     * @param credentials Credentials needed for the client to connect to Azure. Credentials
     * implementing the TokenCredential interface from the @azure/identity package are recommended. For
     * more information about these credentials, see
     * {@link https://www.npmjs.com/package/@azure/identity}. Credentials implementing the
     * ServiceClientCredentials interface from the older packages @azure/ms-rest-nodeauth and
     * @azure/ms-rest-browserauth are also supported.
     * @param subscriptionId The ID of the target subscription.
     * @param [options] The parameter options
     */
    function ManagementLockClient(credentials, subscriptionId, options) {
        var _this = _super.call(this, credentials, subscriptionId, options) || this;
        _this.authorizationOperations = new operations.AuthorizationOperations(_this);
        _this.managementLocks = new operations.ManagementLocks(_this);
        return _this;
    }
    return ManagementLockClient;
}(ManagementLockClientContext));
// Operation Specifications
export { ManagementLockClient, ManagementLockClientContext, Models as ManagementLockModels, Mappers as ManagementLockMappers };
export * from "./operations";
//# sourceMappingURL=managementLockClient.js.map