import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a FirewallPolicyIdpsSignatures. */
export declare class FirewallPolicyIdpsSignatures {
    private readonly client;
    /**
     * Create a FirewallPolicyIdpsSignatures.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Retrieves the current status of IDPS signatures for the relevant policy
     * @param resourceGroupName The name of the resource group.
     * @param firewallPolicyName The name of the Firewall Policy.
     * @param parameters
     * @param [options] The optional parameters
     * @returns Promise<Models.FirewallPolicyIdpsSignaturesListResponse>
     */
    list(resourceGroupName: string, firewallPolicyName: string, parameters: Models.IDPSQueryObject, options?: msRest.RequestOptionsBase): Promise<Models.FirewallPolicyIdpsSignaturesListResponse>;
    /**
     * @param resourceGroupName The name of the resource group.
     * @param firewallPolicyName The name of the Firewall Policy.
     * @param parameters
     * @param callback The callback
     */
    list(resourceGroupName: string, firewallPolicyName: string, parameters: Models.IDPSQueryObject, callback: msRest.ServiceCallback<Models.QueryResults>): void;
    /**
     * @param resourceGroupName The name of the resource group.
     * @param firewallPolicyName The name of the Firewall Policy.
     * @param parameters
     * @param options The optional parameters
     * @param callback The callback
     */
    list(resourceGroupName: string, firewallPolicyName: string, parameters: Models.IDPSQueryObject, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.QueryResults>): void;
}
//# sourceMappingURL=firewallPolicyIdpsSignatures.d.ts.map