/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __assign } from "tslib";
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/firewallPolicyIdpsSignaturesMappers";
import * as Parameters from "../models/parameters";
/** Class representing a FirewallPolicyIdpsSignatures. */
var FirewallPolicyIdpsSignatures = /** @class */ (function () {
    /**
     * Create a FirewallPolicyIdpsSignatures.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function FirewallPolicyIdpsSignatures(client) {
        this.client = client;
    }
    FirewallPolicyIdpsSignatures.prototype.list = function (resourceGroupName, firewallPolicyName, parameters, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            firewallPolicyName: firewallPolicyName,
            parameters: parameters,
            options: options
        }, listOperationSpec, callback);
    };
    return FirewallPolicyIdpsSignatures;
}());
export { FirewallPolicyIdpsSignatures };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "POST",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/firewallPolicies/{firewallPolicyName}/listIdpsSignatures",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.firewallPolicyName,
        Parameters.subscriptionId
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "parameters",
        mapper: __assign(__assign({}, Mappers.IDPSQueryObject), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.QueryResults
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=firewallPolicyIdpsSignatures.js.map