import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { NetworkManagementClientContext } from "../networkManagementClientContext";
/** Class representing a FirewallPolicyIdpsSignaturesFilterValues. */
export declare class FirewallPolicyIdpsSignaturesFilterValues {
    private readonly client;
    /**
     * Create a FirewallPolicyIdpsSignaturesFilterValues.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    constructor(client: NetworkManagementClientContext);
    /**
     * Retrieves the current filter values for the signatures overrides
     * @param parameters
     * @param resourceGroupName The name of the resource group.
     * @param firewallPolicyName The name of the Firewall Policy.
     * @param [options] The optional parameters
     * @returns Promise<Models.FirewallPolicyIdpsSignaturesFilterValuesListResponse>
     */
    list(parameters: Models.SignatureOverridesFilterValuesQuery, resourceGroupName: string, firewallPolicyName: string, options?: msRest.RequestOptionsBase): Promise<Models.FirewallPolicyIdpsSignaturesFilterValuesListResponse>;
    /**
     * @param parameters
     * @param resourceGroupName The name of the resource group.
     * @param firewallPolicyName The name of the Firewall Policy.
     * @param callback The callback
     */
    list(parameters: Models.SignatureOverridesFilterValuesQuery, resourceGroupName: string, firewallPolicyName: string, callback: msRest.ServiceCallback<Models.SignatureOverridesFilterValuesResponse>): void;
    /**
     * @param parameters
     * @param resourceGroupName The name of the resource group.
     * @param firewallPolicyName The name of the Firewall Policy.
     * @param options The optional parameters
     * @param callback The callback
     */
    list(parameters: Models.SignatureOverridesFilterValuesQuery, resourceGroupName: string, firewallPolicyName: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.SignatureOverridesFilterValuesResponse>): void;
}
//# sourceMappingURL=firewallPolicyIdpsSignaturesFilterValues.d.ts.map