/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/networkInterfaceIPConfigurationsMappers";
import * as Parameters from "../models/parameters";
/** Class representing a NetworkInterfaceIPConfigurations. */
var NetworkInterfaceIPConfigurations = /** @class */ (function () {
    /**
     * Create a NetworkInterfaceIPConfigurations.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function NetworkInterfaceIPConfigurations(client) {
        this.client = client;
    }
    NetworkInterfaceIPConfigurations.prototype.list = function (resourceGroupName, networkInterfaceName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            networkInterfaceName: networkInterfaceName,
            options: options
        }, listOperationSpec, callback);
    };
    NetworkInterfaceIPConfigurations.prototype.get = function (resourceGroupName, networkInterfaceName, ipConfigurationName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            networkInterfaceName: networkInterfaceName,
            ipConfigurationName: ipConfigurationName,
            options: options
        }, getOperationSpec, callback);
    };
    NetworkInterfaceIPConfigurations.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return NetworkInterfaceIPConfigurations;
}());
export { NetworkInterfaceIPConfigurations };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkInterfaces/{networkInterfaceName}/ipConfigurations",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.networkInterfaceName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.NetworkInterfaceIPConfigurationListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/networkInterfaces/{networkInterfaceName}/ipConfigurations/{ipConfigurationName}",
    urlParameters: [
        Parameters.resourceGroupName,
        Parameters.networkInterfaceName,
        Parameters.ipConfigurationName,
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.NetworkInterfaceIPConfiguration
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.NetworkInterfaceIPConfigurationListResult
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=networkInterfaceIPConfigurations.js.map