/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/vpnSiteLinkConnectionsMappers";
import * as Parameters from "../models/parameters";
/** Class representing a VpnSiteLinkConnections. */
var VpnSiteLinkConnections = /** @class */ (function () {
    /**
     * Create a VpnSiteLinkConnections.
     * @param {NetworkManagementClientContext} client Reference to the service client.
     */
    function VpnSiteLinkConnections(client) {
        this.client = client;
    }
    VpnSiteLinkConnections.prototype.get = function (resourceGroupName, gatewayName, connectionName, linkConnectionName, options, callback) {
        return this.client.sendOperationRequest({
            resourceGroupName: resourceGroupName,
            gatewayName: gatewayName,
            connectionName: connectionName,
            linkConnectionName: linkConnectionName,
            options: options
        }, getOperationSpec, callback);
    };
    return VpnSiteLinkConnections;
}());
export { VpnSiteLinkConnections };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Network/vpnGateways/{gatewayName}/vpnConnections/{connectionName}/vpnLinkConnections/{linkConnectionName}",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.resourceGroupName,
        Parameters.gatewayName,
        Parameters.connectionName,
        Parameters.linkConnectionName
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.VpnSiteLinkConnection
        },
        default: {
            bodyMapper: Mappers.CloudError
        }
    },
    serializer: serializer
};
//# sourceMappingURL=vpnSiteLinkConnections.js.map